// #define USE_GLUI // glui
#define MACINTOSH //mac
// #define WINDOWS

#include <stdio.h>
#ifdef MACINTOSH
#include "jpeglib.h"
#endif
#ifdef WINDOWS
#include "GL/jpeglib.h"
#endif  
#include <setjmp.h>
#include <stdlib.h>
#include <string.h>



struct my_error_mgr {
  struct jpeg_error_mgr pub;	/* "public" fields */
  jmp_buf setjmp_buffer;	/* for return to caller */
};

typedef struct my_error_mgr * my_error_ptr;

METHODDEF(void)
my_error_exit (j_common_ptr cinfo)
{
  my_error_ptr myerr = (my_error_ptr) cinfo->err;
  (*cinfo->err->output_message) (cinfo);
  longjmp(myerr->setjmp_buffer, 1);
}

char *load_image_jpeg(FILE *infile, int *resox, int *resoy)
{
  struct jpeg_decompress_struct cinfo;
  struct my_error_mgr jerr;
  JSAMPARRAY buffer;		/* Output row buffer */
  int row_stride;		/* physical row width in output buffer */
  char *image, *tmp;

  cinfo.err = jpeg_std_error(&jerr.pub);
  jerr.pub.error_exit = my_error_exit;
  if (setjmp(jerr.setjmp_buffer)) {
    jpeg_destroy_decompress(&cinfo);
    return 0;
  }
  jpeg_create_decompress(&cinfo);

  jpeg_stdio_src(&cinfo, infile);

  (void) jpeg_read_header(&cinfo, TRUE);

  (void) jpeg_start_decompress(&cinfo);

  row_stride = cinfo.output_width * cinfo.output_components;
  buffer = (*cinfo.mem->alloc_sarray)
		((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);
  image = (char *)malloc(sizeof(char) * row_stride * cinfo.output_height);
  tmp = image;
  *resox = cinfo.output_width;
  *resoy = cinfo.output_height;

  while (cinfo.output_scanline < cinfo.output_height) {
    (void) jpeg_read_scanlines(&cinfo, buffer, 1);
    memcpy(tmp, buffer[0], row_stride);
    tmp += row_stride;
  }

  (void) jpeg_finish_decompress(&cinfo);

  jpeg_destroy_decompress(&cinfo);




   return image;
}




char *load_image_jpeg_toumei(FILE *infile, int *resox, int *resoy)
{
  struct jpeg_decompress_struct cinfo;
  struct my_error_mgr jerr;
  JSAMPARRAY buffer;		/* Output row buffer */
  int row_stride;		/* physical row width in output buffer */
  char *image, *tmp;

  cinfo.err = jpeg_std_error(&jerr.pub);
  jerr.pub.error_exit = my_error_exit;
  if (setjmp(jerr.setjmp_buffer)) {
    jpeg_destroy_decompress(&cinfo);
    return 0;
  }
  jpeg_create_decompress(&cinfo);

  jpeg_stdio_src(&cinfo, infile);

  (void) jpeg_read_header(&cinfo, TRUE);

  (void) jpeg_start_decompress(&cinfo);

  row_stride = cinfo.output_width * cinfo.output_components;
  buffer = (*cinfo.mem->alloc_sarray)
		((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);
  image = (char *)malloc(sizeof(char) * row_stride * cinfo.output_height);
  tmp = image;
  *resox = cinfo.output_width;
  *resoy = cinfo.output_height;

  while (cinfo.output_scanline < cinfo.output_height) {
    (void) jpeg_read_scanlines(&cinfo, buffer, 1);
    memcpy(tmp, buffer[0], row_stride);
    tmp += row_stride;
  }

  (void) jpeg_finish_decompress(&cinfo);

  jpeg_destroy_decompress(&cinfo);

  int n_x =  cinfo.output_width;
  int n_y = cinfo.output_height;
  char* image2;
  image2 = (char *)calloc((n_x) *(n_y) * 4, sizeof(char));
  for (int i = 0;i<n_x*n_y;++i){
    image2[i*4+0] = image[i*3+0];
    image2[i*4+1] = image[i*3+1];
    image2[i*4+2] = image[i*3+2];
    
    if (((int)image[i*3+0] + (int)image[i*3+1] +  (int)image[i*3+2] >=0)&&
        ((int)image[i*3+0] + (int)image[i*3+1] +  (int)image[i*3+2] <=10)){
      image2[i*4+3] = (char)0;
    }else{
      image2[i*4+3] = (char)255;
    } 
  }
  return image2;

  //  return image;
}



